import 'package:agility_redux/agility_redux.dart';

class PublicState with ReduxStateItem<PublicState> {
  PublicState({
    required this.a,
  });

  final int a;

  PublicState copyWith({
    required int a,
  }) {
    return PublicState(
      a: a ?? this.a,
    );
  }

  @override
  PublicState clone() {
    return PublicState(a: a);
  }

  @override
  String toString() {
    return 'PublicState{a: $a} $hashCode';
  }
}

class PrivateState with ReduxStateItem<PrivateState> {
  PrivateState({
    required this.b,
  });

  final int b;

  PrivateState copyWith({
    required int b,
  }) {
    return PrivateState(
      b: b ?? this.b,
    );
  }

  @override
  PrivateState clone() {
    return PrivateState(b: b);
  }

  @override
  String toString() {
    return 'PrivateState{b: $b}';
  }
}
