import 'dart:async';

import 'package:agility_redux/agility_redux.dart';

import 'data_model/action.dart';
import 'data_model/state.dart';

part 'redux_bloc.g.dart';

class TestReduxBloc$ extends SimpleReduxBloc<PublicState, PrivateState> {
  @override
  void initBloc() {}

  @override
  PrivateState get initialPrivateState => PrivateState(b: 1);

  @override
  PublicState get initialState => PublicState(a: 1);

  @override
  String get moduleName => 'test';
}

// class TestReduxBloc extends TestReduxBloc$ {
//   TestReduxBloc() {
//     handler = TestReduxBlocActionHandler(this);
//   }
//
//   late TestReduxBlocActionHandler handler;
//
//   @override
//   PublicState reducer(ReduxAction action, PublicState state, PrivateState privateState) {
//     PublicState newStatus = state;
//
//     if (action is UpdateAAction) {
//       newStatus = handler.updateA(action, newStatus, privateState);
//     }
//
//     return newStatus;
//   }
//
//   @override
//   PrivateState privateReducer(ReduxAction action, PublicState state, PrivateState privateState) {
//     PrivateState newState = privateState;
//
//     if (action is UpdateBAction) {
//       newState = handler.updateB(action, state, newState);
//     }
//
//     return newState;
//   }
//
//   @override
//   FutureOr<ReduxAction> middleware(DispatchFunction dispatcher, ReduxState state, ReduxAction action) {
//     if (action is AddAAction) {
//       () async {
//         if (handler.check(state)) {
//           handler.addA(dispatcher, state, action);
//         }
//       }();
//     }
//     //
//     else if (action is AddBAction) {
//       () async {
//         handler.addB(dispatcher, state, action);
//       }();
//     }
//     return action;
//   }
// }

@ReduxActionHandler(TestReduxBloc$)
class TestReduxBlocActionHandler {
  final TestReduxBloc$ reduxBloc;

  TestReduxBlocActionHandler(this.reduxBloc);

  bool check(ReduxState state) {
    return true;
  }

  // A 增加1
  @Middleware(AddAAction)
  Future<void> addA(DispatchFunction dispatcher, ReduxState state, AddAAction action) async {
    PublicState publicState = state.publicState<PublicState>();
    dispatcher(UpdateAAction(a: publicState.a + 1));
  }

  // B 增加1
  @Middleware(AddBAction)
  Future<void> addB(DispatchFunction dispatcher, ReduxState state, AddBAction action) async {
    PrivateState privateState = state.privateState<PrivateState>();
    dispatcher(UpdateBAction(b: privateState.b + 1));
  }

  // 更新 A
  @Reducer(UpdateAAction)
  PublicState updateA(UpdateAAction action, PublicState state, PrivateState privateState) {
    return state.copyWith(
      a: action.a,
    );
  }

  // 更新 B
  @PrivateReducer(UpdateBAction)
  PrivateState updateB(UpdateBAction action, PublicState state, PrivateState privateState) {
    return privateState.copyWith(
      b: action.b,
    );
  }
}
